mob/proc/peg(hole in sequence(codelength), colour in colours)
	set category=null
	set desc="(hole number, colour) Place a peg in a hole, to form a guess."
	////Place a peg
	//Make sure the game has started
	if (!gamestarted)
		src << "The game has not yet started."
		return
	//Create the peg
	var/obj/peg/P=new(null,colour)
	//Move it to its position
	var/turf/T=locate(14-hole,1,1)
	for (var/obj/peg/OldPeg in T) del OldPeg
	P.loc=T

mob/var/cursor=0

mob/proc/movecursor(amt as num)
	////Move the selection
	//Game must have started
	if (!gamestarted) return
	//Remove old cursor
	var/turf/T=locate(14-cursor,1,1)
	T.text=initial(T.text)
	//Move cursor
	if (cursor==0)
		if (amt<0) cursor=codelength
		else cursor=1
	else
		cursor+=amt
	if (cursor>codelength) cursor=1
	else if (cursor<1) cursor=codelength
	//Redraw cursor
	T=locate(14-cursor,1,1)
	T.text=dd_replacetext(T.text,"#774400","#333333")

mob/proc/pegreplace(direction as num)
	////For the up/down arrow keys
	//Make sure the cursor is selecting something
	if (!cursor) return
	//Get existing peg
	var/obj/peg/P=locate() in locate(14-cursor,1,1)
	//Select new colour
	var/colourindex
	if (P)
		colourindex=colours.Find(P.colour)+direction
	else
		colourindex=direction
	if (colourindex<0) colourindex=length(colours)
	if (colourindex>length(colours)) colourindex=0
	//Delete peg
	del P
	//Create new peg
	if (colourindex) new/obj/peg(locate(14-cursor,1,1),colours[colourindex])