var/codelength=5
var/colournum=8
var/allowdup=1
var/gamestarted=0
var/thecode[0]
var/currentrow=3

mob/verb/start()
	set category=null
	if (gamestarted) return
	gamestarted=1
	verbs-=/mob/verb/start
	verbs+=/mob/proc/peg
	verbs+=/mob/proc/guess
	gamesetup()

mob/proc/gamesetup()
	//Ask length of code
	var/length=0
	while(length<2 || length>7)
		length=round(input(src,"How long do you want the code to be? (2-7)","Length",codelength) as num)
	codelength=length
	//Ask number of colours
	var/thenum=0
	while(thenum<2 || thenum>length(allcolours))
		thenum=round(input(src,"How many possible colours do you want? (2-[length(allcolours)])",
			"Number of colours",colournum) as num)
	colournum=thenum
	//Ask whether duplicates are allowed
	var/dup=""
	if (colournum<length) dup="Yes"
	while (dup!="Yes" && dup!="No")
		dup=alert(src,"Do you want to allow the same colour to occur multiple times throughout the code?",
			"Allow duplicate colours?","Yes","No")
	if (dup=="Yes") allowdup=1
	else allowdup=0
	//Clear pegs
	for (var/obj/peg/P) del P
	//Clear score markers
	for (var/obj/marker/M) del M
	//Clear peg holes
	for (var/turf/T) new /turf/bg(T)
	//New peg holes
	for (var/turf/T in block(locate(13,3,1),locate(14-length,20,1))) new /turf/peghole(T)
	for (var/turf/T in block(locate(13,1,1),locate(14-length,1,1))) new /turf/peghole(T)
	//Create Done button
	new/turf/done/d(locate(15,1,1))
	new/turf/done/o(locate(16,1,1))
	new/turf/done/n(locate(17,1,1))
	new/turf/done/e(locate(18,1,1))
	//Reset cursor
	cursor=0
	//Set number of colours
	colours=allcolours.Copy()
	colours.Cut(colournum+1)
	//Set current row
	currentrow=3
	//Generate code
	var/availcolours=colours.Copy()
	thecode.Cut()
	for (var/X=1 to codelength)
		var/c=pick(availcolours)
		thecode+=c
		if (!allowdup) availcolours-=c
	//Tell them to begin
	world << "Code generated; length [codelength], with [colournum] possible colour\s."
	if (allowdup) world << "Total possible combinations: [cr_num2text(colournum**codelength)]"
	world << "Game on!"

mob/proc/gameover(win)
	if (win)
		src << "<b class=highlight>Your guess was correct, you win!</b>"
		src << "That was a performance worthy of <a href='http://www.byondscape.com'>BYONDscape</a> itself!"
	else
		src << "<b class=highlight>You ran out of guesses. Sorry, you lose.</b>"
		src << "The correct answer was: \..."
		for (var/X in thecode) src << "<font color=[colours[X]]>[X]</font> \..."
		src << ""
	src << "Press F2 to play again."
	gamestarted=0
	verbs+=/mob/verb/start
	verbs-=/mob/proc/peg
	verbs-=/mob/proc/guess